/*
	1. init is called when thread starts
	2. idle1 and idle2 are called in sequence from the thread
	3. click is called if there is a mousedown in the plugin area
	4. ipc will pass two values to the plugin
	5. kill is called when thread ends
*/

typedef struct forty_two_plugin_api forty_two_plugin_api;

typedef struct forty_two_plugin_api
{
	int	(*init)(void);
	int	(*kill)(void);
	int	(*idle1)(void);
	int	(*idle2)(void);
	int	(*click)(Point *loc);
	int	(*ipc)(int type,unsigned long msg);
	void	(*update)(forty_two_plugin_api *plugin); /* filled in by plugin manager */
	
	short		req_dialog_item;
	GWorldPtr	port;
};

int forty_two_init(DialogPtr dialog);
void forty_two_kill(void);
void forty_two_thread(void);
void forty_two_update(forty_two_plugin_api *plugin);
void forty_two_update_all(void);
void forty_two_click(Point *pt);