#pragma once
#ifndef INCLUDED_PO_TQUEUE
#define INCLUDED_PO_TQUEUE

//////////////////////////////////////////////////////
//
//	PO_TQueue
//	Template based interface to PO_Queue
//
//////////////////////////////////////////////////////

#include "PO_Queue.h"


template <class T>
class PO_TQueueElem : public PO_MQueueElem
{
public:
	
	T*	Next()	{return (T*)PO_MQueueElem::Next();}
	
};


template <class T>
class PO_TQueue : public PO_Queue
{
public:
	
	void 	Enqueue(PO_TQueueElem<T>* inObj)	{ PO_Queue::Enqueue(inObj); }
	OSErr	Dequeue(PO_TQueueElem<T>* inObj) 	{ return PO_Queue::Dequeue(inObj); }
	UInt32	GetNumElems()					{ return PO_Queue::GetNumElems();}
	
	T*	 	GetHead()						{ return (T*)PO_Queue::GetHead();}
	T*	 	GetTail()						{ return (T*)PO_Queue::GetTail();}
	
};



template <class T>
class PO_TQIterator : public PO_QIterator
{
public:
	PO_TQIterator(PO_Queue& queue)	: PO_QIterator(queue) {}
	
	Boolean		MoreQ()				{ return PO_QIterator::MoreQ(); }
	T*			GetNext()			{ return static_cast<T*>(PO_QIterator::GetNext());}
	void		Reset()				{ PO_QIterator::Reset();}
	
};




#endif
