#pragma once
#ifndef INCLUDED_PO_REFCOUNTED
#define INCLUDED_PO_REFCOUNTED
////////////////////////////////////////////////////////////////////////////////////////
//
//	INTERFACE:		PO_RefCounted
//
//	DESCRIPTION:	Public base class for reference counting using the
//					PO_Ref smart pointer  (See PO_Ref.h)
//
//	AUTHORS:		Bill Hubauer (BH)
//
//	HISTORY:
//		WHEN		WHO		WHAT
//		----		---		----
//		??			BH		Created
//		3/13/97		BH		Cleaned up for "Power On Libraries"
//
////////////////////////////////////////////////////////////////////////////////////////

#ifndef INCLUDED_PO_REF
#include "PO_Ref.h"
#endif

////////////////////////////////////////////////////////////////////////////////////////
//	PUBLIC INTERFACE
////////////////////////////////////////////////////////////////////////////////////////

class	PO_RefCounted
{
public:
	PO_RefCounted()
		:	_rc_count(0) {}
	
	virtual ~PO_RefCounted() {}
	
	void	_AddReference()						{ _rc_count++; }
	void	_RemoveReference(Boolean deleteQ)	{ _rc_count--; 
													if(deleteQ && (_rc_count == 0)) delete this; }
	UInt32	_GetRefCount()						{ return _rc_count; }
private:
	UInt32	_rc_count;	
};
	


#endif
