#pragma once

#ifndef _PO_DebugUtils_
#define _PO_DebugUtils_

#ifndef __TYPES__
#include <Types.h>
#endif

struct PO_DebugUtils
{
	static void				Debugger();
	static void				DebugStr(ConstStr255Param str);

	// these two functions are from JW's DebuggingUtils (docs below)
	static char* 			FormatCStr(char *outputStr, const char* formatStr, ...);
	static void 			DebugCStr(const char* formatStr, ...);

	
	static Boolean			MacsBugInstalledQ();
	static Boolean			MacsBugActiveQ();
} ;

#ifndef NDEBUG
	#define PO_DebugUtils_DebugStr(a)	PO_DebugUtils::DebugStr(a)
#else
	#define PO_DebugUtils_DebugStr(a)	(void)
#endif


// DebugCStr Docs (From JW's DebuggingUtils.h)

// The following functions are interrupt-safe routines used for generating formatted
// strings.  All of the input and output strings are in C format.  The format string 
// uses similar type specifiers as stdio's printf function.  For example:
//
//		DebugCStr("This is a string: '%s', a short: '%d', a long: '%l', a pointer: '%x',
//			"test string", 12, 1234L, &foo);
//
// Would enter Macsbug with the string:
//
//		"This is a string: 'test string', a short: '12', a long: '1234', a pointer: '0x001FA340'"
//
// The format specifiers currently recognized are: 
// 		%s is string				"%s", char *str
// 		%d is short decimal			"%d", short num
// 		%l is long decimal			"%l", long num				
// 		%x is long hexidecimal		"%x", long num or pointer 	(must take 4 bytes on stack)
//		%p is Point					"%p", Point* point			(pass address of a point)
//		%r is Rect					"%r", Rect* rect			(pass address of a rect)
//		%o is OSType				"%o", OSType 'OSTp'		
//		%P is pascal string			"%P", StringPtr s


#endif