////////////////////////////////////////////////////////////////////////
//
//	CLASS:	TR_InetResolver
//
//	DESCRIPTION:
//
//	HISTROY:
//		WHEN		WHO					WHAT
//		----		---					----
//		Tue, Oct 28, 1997		Bill Hubauer				created
//
////////////////////////////////////////////////////////////////////////


////////////////////////////////////////////////////////////////////////
//	INCLUDES
////////////////////////////////////////////////////////////////////////

#include "TR_InetResolver.h"
#include <OpenTptInternet.h>
#include <string.h>

TR_InetResolver	TR_InetResolver::sInetResolver;



TR_InetResolver::TR_InetResolver()
	:	fInitedQ(false)
{
	
}


OSStatus	TR_InetResolver::_Open()
{
	OSStatus		err = noErr;

	if(!fInitedQ){
		fRef = OTOpenMapper(OTCreateConfiguration(kDNRName), 0,&err);
		if(err == noErr){
			fInitedQ = true;
		}
	}
	
	return err;
}


TR_InetResolver::~TR_InetResolver()
{
	
}


OSStatus	TR_InetResolver::_Resolve(char* inAddress,UInt32& outHost,UInt16& outPort)
{
	OSStatus		err = noErr;
	
	err = _Open();
	if(err == noErr){
		TLookupRequest		request;
		
		request.name.maxlen = strlen(inAddress);
		request.name.len = request.name.maxlen;
		request.name.buf = (unsigned char*)inAddress;
		request.addr.len = 0;
		request.maxcnt = 1;
		request.timeout = 0;
		
		TLookupReply		reply;
		const UInt32		kBufferSize = 1024;
		char				buffer[kBufferSize];
		
		reply.names.maxlen = kBufferSize;
		reply.names.buf = (UInt8*)buffer;
		
		err = OTLookupName(fRef,&request,&reply);
		if(err == noErr){
			InetAddress*	ipAddress = (InetAddress*) (buffer+4);
			outHost = ipAddress->fHost;
			outPort = ipAddress->fPort;
		}
	}

	return err;
}
