////////////////////////////////////////////////////////////////
//
//	CLASS:			TR_Allocator
//	
//	DESCRIPTION:	TR_Allocator is a protocol class that defines
//					the interface to a simple allocator.
//
//	AUTHORS:		Bill Hubauer (BH)
//
//	HISTORY:
//		WHEN		WHO		WHAT
//		----		---		----
//		5/22		BH		Created and Debugged
//
////////////////////////////////////////////////////////////////

////////////////////////////////////////////////////////////////
//	INCLUDES
////////////////////////////////////////////////////////////////

#include "TR_Allocator.h"


////////////////////////////////////////////////////////////////
//	PRIVATE CLASSES
////////////////////////////////////////////////////////////////

class	TR_DefaultAllocator : public TR_Allocator
{
	public:
		
		TR_DefaultAllocator() { gDefaultAllocator = this; }
		
		virtual void*	Allocate(UInt32 inSize)
		{
			return new char[inSize];
		}
		
		
		virtual void	Free(void* inData)
		{
			if(inData != NULL){
				delete [] ((char*)inData);
			}
		}
};

////////////////////////////////////////////////////////////////
//	EXPORTED VARIABLES
////////////////////////////////////////////////////////////////

static TR_DefaultAllocator	 __DefaultAllocator;
TR_Allocator*				gDefaultAllocator;

		