////////////////////////////////////////////////////////////////
//
//	CLASS:			TR_Buffer
//	
//	DESCRIPTION:	TR_Buffer is a ref counted buffer for use
//					with the TR (Transaction) library.
//
//	AUTHORS:		Bill Hubauer (BH)
//
//	HISTORY:
//		WHEN		WHO		WHAT
//		----		---		----
//		5/22		BH		Created and Debugged
//
////////////////////////////////////////////////////////////////

////////////////////////////////////////////////////////////////
//	INCLUDES
////////////////////////////////////////////////////////////////

#include "TR_Buffer.h"
#include "TR_Allocator.h"


////////////////////////////////////////////////////////////////
//	IMPLEMENTATION
////////////////////////////////////////////////////////////////


TR_Buffer::TR_Buffer()
{
	SetLogicalSize(fSize);
}


TR_Buffer::~TR_Buffer()
{
}


		
void*	TR_Buffer::operator new(UInt32 inObjectSize,TR_Allocator& inAllocator,UInt32 inBufferSize)
{
	TR_Buffer*		result = (TR_Buffer*) inAllocator.Allocate(inBufferSize + inObjectSize);
	
	if(result != NULL){
		result->fSize = inBufferSize;
		result->fAllocator = &inAllocator;
		result->fMem = ((char*)result) + inObjectSize;
	}
	
	return result;
}

TR_Buffer*		TR_Buffer::New(UInt32 inBufferSize,TR_Allocator* inAllocator )
{
	if(inAllocator == NULL){
		inAllocator = gDefaultAllocator;
	}
	return new(*inAllocator,inBufferSize) TR_Buffer;
}



void	TR_Buffer::operator delete(void* inObj)
{
	if(inObj != NULL){
		TR_Allocator*	alloc = ((TR_Buffer*)inObj)->fAllocator;
		alloc->Free(inObj);
	}
}



