#include "TR_BufferPool.h"
#include "TR_Buffer.h"



TR_BufferPool::TR_BufferPool(UInt32 inBufferSize)
	:	fAllocator(inBufferSize + TR_Buffer::GetBufferSizeOverhead()),
		fBufferSize(inBufferSize)
{
	
}


TR_BufferPool::~TR_BufferPool()
{

}


		
OSStatus				TR_BufferPool::IncreasePoolSize(UInt32		inNumberOfBuffers)
{	
	return fAllocator.IncreasePoolSize(inNumberOfBuffers);	
}


		
UInt32				TR_BufferPool::GetPoolSize()
{
	return fAllocator.GetPoolSize();
}


UInt32				TR_BufferPool::GetNumFree()
{
	return fAllocator.GetNumFree();
}


		
bool				TR_BufferPool::Allocate(PO_Ref<TR_Buffer>& outBuffer,UInt32 inLogicalSize)
{
	if(inLogicalSize <= fBufferSize){
		outBuffer = TR_Buffer::New(inLogicalSize,&fAllocator);
		return !outBuffer.IsNullQ();
	}else{
		return false;
	}
}

TR_BufferPool::TR_BufferPool(UInt32 inMaxBufferSize,UInt32 inInitialSize,UInt32 inMinFree,
						UInt32 inGrowSize,UInt32 inMaxSize)
	:	fAllocator(inMaxBufferSize + TR_Buffer::GetBufferSizeOverhead(),
					inInitialSize,inMinFree,inGrowSize,inMaxSize),
		fBufferSize(inMaxBufferSize)
{
	
}

UInt32				TR_BufferPool::GetHighestUsage()
{
	return fAllocator.GetHighestUsage();
}





