#include "TR_PoolAllocator.h"
#include "PO_Assert.h"


void*	TR_PoolAllocator::Allocate(UInt32 inSize)//Override
{
	void*		result = NULL;

	assert(inSize <= fPool.GetObjectSize());
	if(inSize <= fPool.GetObjectSize()){
		result = fPool.AllocateObject();
	}
	
	return result;
}


void	TR_PoolAllocator::Free(void* inData) //Override
{
	if(inData != NULL){
		fPool.FreeObject(inData);
	}
}


TR_PoolAllocator::~TR_PoolAllocator()//Override
{
}


TR_PoolAllocator::TR_PoolAllocator(UInt32	inObjSize)
	:	fPool(inObjSize)
{

}


OSStatus	TR_PoolAllocator::IncreasePoolSize(UInt32 inByHowMuch)
{
	OSStatus		err = noErr;
	
	err = fPool.IncreasePoolSize(inByHowMuch);

	return err;
}


UInt32		TR_PoolAllocator::GetPoolSize()
{
	return fPool.GetPoolSize();
}


UInt32		TR_PoolAllocator::GetNumFree()
{
	return fPool.GetNumFree();
}

TR_PoolAllocator::TR_PoolAllocator(UInt32 inObjSize,UInt32 inInitialSize,UInt32 inMinFree,
						UInt32 inGrowSize,UInt32 inMaxSize)
	:	fPool(inObjSize,inInitialSize,inMinFree,inGrowSize,inMaxSize)
{
	
}


UInt32		TR_PoolAllocator::GetHighestUsage()
{
	return fPool.GetHighestUsage();
}

