////////////////////////////////////////////////////////////////
//
//	CLASS:			TR_OutgoingRequest
//	
//	DESCRIPTION:	TR_OutgoingRequest is the public interface
//					for sending requests to a responder
//
//	AUTHORS:		Bill Hubauer (BH)
//
//	HISTORY:
//		WHEN		WHO		WHAT
//		----		---		----
//		5/22		BH		Created and Debugged
//
////////////////////////////////////////////////////////////////


////////////////////////////////////////////////////////////////
//	INCLUDES
////////////////////////////////////////////////////////////////

#include "TR_Request_ATK.h"
#include "TR_NetworkTypes.h"
#include "TR_Buffer.h"

TR_OutgoingRequest::TR_OutgoingRequest()
{

}


TR_OutgoingRequest::~TR_OutgoingRequest()
{


}






UInt32	TR_RequestFactory::MaxRequestSizeForAddressType(UInt32 inAddressType)
{
	if(inAddressType == kAddressTypeAppleTalk){
		return 578;	
	}else{
		DebugStr("\pIP Unimplemented");
		return 0;
	}
}


TR_OutgoingRequest*		TR_RequestFactory::New
(
 	const 	TR_NetworkAddress& 	inAddress,
	PO_Ref<TR_Buffer>			inReqData,
	PO_Ref<TR_Buffer>			inRespBuffer,
	TR_Allocator*				inAllocator ,
	Priority					inPriority )
{
	if(inAddress.GetType() == kAddressTypeAppleTalk){
		return new(inAllocator) TR_OutgoingRequest_ATK(inAddress,inReqData,inRespBuffer,
													inPriority);
	}else{
		DebugStr("\pIP Unimplemented");
		return NULL;
	}
}


TR_RequestFactory::~TR_RequestFactory()
{
	
}


TR_RequestFactory::TR_RequestFactory()
{
	
}


UInt32	TR_RequestFactory::sizeof_TR_OutgoingRequest(UInt32 inAddressType)
{
	if(inAddressType == kAddressTypeAppleTalk){
		return sizeof(TR_OutgoingRequest_ATK);
	}else{
		DebugStr("\pIP Unimplemented");
		return 0;
	}
	
}
