#pragma once
//////////////////////////////////////////////////////////////////////////
//	
//	TR_Responder_ATK
//
//	This class defines the AppleTalk specific implementation
//	of a responder object
//
//	THIS IS NOT A PUBLIC INTERFACE FILE
//
//////////////////////////////////////////////////////////////////////////


//////////////////////////////////////////////////////////////////////////
//	INCLUDES
//////////////////////////////////////////////////////////////////////////

#include "TR_Responder_Common.h"

//////////////////////////////////////////////////////////////////////////
//	PRIVATE CLASSES
//////////////////////////////////////////////////////////////////////////

class	TR_Responder_ATK : public TR_Responder_Common
{
	public:
		TR_Responder_ATK();
		virtual ~TR_Responder_ATK();
		
		virtual OSStatus	Initialize
		(
			const TR_NetworkName&			 	inName,
			UInt32 								inInitialNumRequests,
			UInt32								inMinFreeRequests,
			UInt32								inGrowSize,
			UInt32								inMaxNumRequests,
			UInt32								inMaxRequestBufferSize,
			TR_Allocator*						inRequestAllocator 
		);

		virtual void	GetNetworkAddress(TR_NetworkAddress& outMyAddress);

		virtual TR_IncommingRequest_Common*	MakeIncommingRequest(
												TR_Allocator* inAllocator,
												PO_Ref<TR_Buffer>	inReqBuffer);

		virtual OSStatus		InitNetwork();
		virtual void			CloseNetwork();
	private:
		friend class	TR_ATQHelper;
		friend class	TR_IncommingRequest_ATK;
		
		void			ATOpen();
		void			ATClose();


		bool				fATPSocketOpenQ;
		short				fATPSocket;
		NamesTableEntry		fNTE;
		bool				fNBPRegisteredQ;
		TR_ATQHelper*		fATQHelper;


};

  
  
  
  
class	TR_IncommingRequest_ATK : public TR_IncommingRequest_Common
{
	public:
		TR_IncommingRequest_ATK(PO_Ref<TR_Buffer> inBuffer,TR_Responder_Common* inResponder);
		virtual ~TR_IncommingRequest_ATK();
		
		virtual void	GetSender(TR_NetworkAddress& outSender) const;
		virtual void	SendResponse(PO_Ref<TR_Buffer> inResponseBuffer,void* inUserData,
									bool inAsyncQ);


		virtual OSStatus		Initialize();
		virtual OSStatus		Listen();
		virtual void			StopListening();
		virtual void			KillResponse();

 
		void					ATPCompletion();
		
		
		struct ATPExtPB : ATPParamBlock
		{
			long						globals;
			TR_IncommingRequest_ATK*	thisObj;
		};

		ATPExtPB			fPB;
		ATPCompletionUPP	fCompletionUPP;
		BDSType				fBDS;
		
#if		GENERATINGCFM		
		static pascal void		ATPCompletionStub(ATPParamBlock* inPB);
#else
		static pascal void		ATPCompletionStub();
#endif

};

