#pragma once
#ifndef INCLUDED_TR_ALLOCATOR
#define INCLUDED_TR_ALLOCATOR
////////////////////////////////////////////////////////////////
//
//	CLASS:			TR_Allocator
//	
//	DESCRIPTION:	TR_Allocator is a protocol class that defines
//					the interface to a simple allocator.
//
//	AUTHORS:		Bill Hubauer (BH)
//
//	HISTORY:
//		WHEN		WHO		WHAT
//		----		---		----
//		5/22		BH		Created and Debugged
//
////////////////////////////////////////////////////////////////



class TR_Allocator
{
	public:
		TR_Allocator() {}
		virtual ~TR_Allocator() {}
	
		virtual void*	Allocate(UInt32 inSize) = 0;
		virtual void	Free(void* inData) = 0;
		
};


		
extern TR_Allocator*		gDefaultAllocator;		// uses new char[size]



///////////////////////////////////////////////////////
//
//	New and Delete for use with allocators
//	
///////////////////////////////////////////////////////

inline void* operator new(UInt32 inSize,TR_Allocator* inAllocator)
{
	return inAllocator->Allocate(inSize);
}

template <class T>
void	Tdelete(T* inObj,TR_Allocator* inAllocator)
{
	inObj->~T();
	inAllocator->Free(inObj);
}

#endif