#pragma once
#ifndef INCLUDED_TR_POOLALLOCATOR
#define INCLUDED_TR_POOLALLOCATOR

////////////////////////////////////////////////////////////////////////
//	
//	TR_PoolAllocator
//
//	This is a class that conforms to the TR_Allocator protocol
//	that is implemented in terms of a PO_ObjectPool
//	This class is nothing more than a thin "adapter" that allows
//	clients of TR_Allocators to allocate from a PO_ObjectPool.
//	
//////////////////////////////////////////////////////////////////////////



//////////////////////////////////////////////////////////////////////////
//	INCLUDES
//////////////////////////////////////////////////////////////////////////

#include "TR_Allocator.h"
#include "PO_ObjectPool.h"



//////////////////////////////////////////////////////////////////////////
//	PUBLIC CLASSES
//////////////////////////////////////////////////////////////////////////

class TR_PoolAllocator : public TR_Allocator
{
	public:
	
		// fixed size
		TR_PoolAllocator(UInt32	inObjSize);
		
		// growable
		TR_PoolAllocator(UInt32 inObjSize,UInt32 inInitialSize,UInt32 inMinFree,
						UInt32 inGrowSize,UInt32 inMaxSize);
		virtual ~TR_PoolAllocator();

		OSStatus	IncreasePoolSize(UInt32 inByHowMuch);
		UInt32		GetPoolSize();
		UInt32		GetNumFree();
		UInt32		GetHighestUsage();

			// from TR_Allocator
		virtual void*	Allocate(UInt32 inSize);
		virtual void	Free(void* inData);

 
	private:
		PO_ObjectPool	fPool;

};




#endif

