#ifndef _BASEMENUMANAGER_
#define _BASEMENUMANAGER_

#ifndef _LLIST_
#include "LList.h"
#endif

#ifndef _MENU_
#include "Menu.h"
#endif

#ifndef _MENUMANAGER_
#include "MenuManager.h"
#endif

#ifndef _WINDOW_
#include "Window.h"
#endif


typedef struct BaseMenuObject
{
	BaseMenuObject	*next;
	UInt32			fMenuID;
	Menu			*fMenuObject;
} BaseMenuObject;


typedef class BaseMenuManager : public MenuManager
{
public:
	LList<BaseMenuObject>		fMenuList;
	
	virtual void DoAddMenu(Menu *menu);
	virtual void DoMenuUpdates(void);
	virtual void DoSelect(UInt32 menu,UInt32 item);
	virtual void DoWindowNotice(Window *window,Boolean isBeingAdded);
	virtual void DoWindowActivation(Window *window,Boolean isBeingActivated);
	virtual Menu *DoGetMenu(UInt32 menuID);
	
	virtual void HandleAddMenu(Menu *menu);
	virtual void HandleMenuUpdate(Menu *menu);
	virtual void HandleSelect(Menu *menu,UInt32 item);
	virtual void HandleWindowNotice(Menu *menu,Window *window,Boolean isBeingAdded);
	virtual void HandleWindowActivation(Menu *menu,Window *window,Boolean isBeingActivated);
	virtual Menu *HandleGetMenu(UInt32 menuID);
} BaseMenuManager;


#endif /* _BASEMENUMANAGER_ */
