#ifndef _BASEWINDOW_
#define _BASEWINDOW_

#ifndef _WINDOW_
#include "Window.h"
#endif


typedef class BaseWindow : public Window
{
public:
	BaseWindow(void);
	BaseWindow(UInt32 windowID);
	BaseWindow(Boolean isFloatingWindow,short procID,Boolean goAwayFlag);
	virtual ~BaseWindow(void);
	
	virtual Boolean DoGetParam(OSType param,SInt32 *value);
	virtual Boolean DoSetParam(OSType param,SInt32 value);
	virtual void DoDialogEvent(EventRecord *event);
	virtual void DoClose(void);
	virtual void DoKey(UInt32 key,UInt32 modifiers);
	virtual void DoClick(Point where,UInt32 modifiers,SInt32 part);
	virtual void DoUpdate(void);
	virtual void DoUpdateCursor(Point mouse,UInt32 modifiers);
	virtual void DoIdleTime(EventRecord *event,Point mouse,UInt32 modifiers);
	virtual void DoSetActivationState(Boolean isActive);
	virtual void DoSetSuspensionState(EventRecord *event,Boolean isSuspended);
	
	virtual Boolean HandleGetParam(OSType param,SInt32 *value);
	virtual Boolean HandleSetParam(OSType param,SInt32 value);
	virtual void HandleClose(void);
	virtual void HandleZoomIn(void);
	virtual void HandleZoomOut(void);
	virtual void HandleDrag(Point start);
	virtual void HandleMove(Point where);
	virtual void HandleGrow(Point start);
	virtual void HandleResize(UInt32 height,UInt32 width);
	virtual void HandleKey(UInt32 key,UInt32 modifiers);
	virtual void HandleClick(Point where,UInt32 modifiers);
	virtual void HandleActivate(void);
	virtual void HandleDeactivate(void);
	virtual void HandleCursorUpdate(Point mouse,UInt32 modifiers);
	virtual void HandleIdleTime(Point mouse,UInt32 modifiers);
	virtual void HandleDraw(void);
} BaseWindow;


#endif /* _BASEWINDOW_ */
