#ifndef _BASEWINDOWMANAGER_
#define _BASEWINDOWMANAGER_

#ifndef _LLIST_
#include "LList.h"
#endif

#ifndef _WINDOW_
#include "Window.h"
#endif

#ifndef _WINDOWMANAGER_
#include "WindowManager.h"
#endif





typedef struct BaseWindowObject
{
	BaseWindowObject	*next;
	WindowPtr			fWindowID;
	Window				*fWindowObject;
} BaseWindowObject;


typedef class BaseWindowManager : public WindowManager
{
protected:
	BaseWindowObject *GetWindowObject(WindowPtr window);
	
public:
	LList<BaseWindowObject>		fWindowList;
	Boolean						fSuspended;
	
	BaseWindowManager(void);
	
	virtual void DoAddWindow(Window *window);
	virtual void DoDeleteWindow(Window *window);
	virtual void DoClick(Point where,UInt32 modifiers,WindowPtr window,SInt32 part);
	virtual void DoIdleTime(EventRecord *event,Point mouse,UInt32 modifiers);
	virtual void DoActivation(WindowPtr window,Boolean isActivating);
	virtual void DoSuspendResume(EventRecord *event,Boolean isSuspend);
	
	virtual Window *DoGetFrontWindow(void);
	virtual Window *DoGetNextWindow(Window *window);
	virtual Window *DoGetWindow(WindowPtr window);
	
} BaseWindowManager;


#endif /* _BASEWINDOWMANAGER_ */
