#ifndef _WINDOW_
#define _WINDOW_

#include <Windows.h>


enum
{
	kFloater		= (1L << 0),
	kDialog			= (1L << 1),
	kModal			= (1L << 2),
	kActive			= (1L << 3),
	kSuspended		= (1L << 4)
};


typedef class Window
{
public:
	WindowPtr	fWindow;
	UInt32		fFlags;
	
	virtual Boolean DoGetParam(OSType param,SInt32 *value) = 0;
	virtual Boolean DoSetParam(OSType param,SInt32 value) = 0;
	virtual void DoDialogEvent(EventRecord *event) = 0;
	virtual void DoClose(void) = 0;
	virtual void DoKey(UInt32 key,UInt32 modifiers) = 0;
	virtual void DoClick(Point where,UInt32 modifiers,SInt32 part) = 0;
	virtual void DoUpdate(void) = 0;
	virtual void DoUpdateCursor(Point mouse,UInt32 modifiers) = 0;
	virtual void DoIdleTime(EventRecord *event,Point mouse,UInt32 modifiers) = 0;
	virtual void DoSetActivationState(Boolean isActive) = 0;
	virtual void DoSetSuspensionState(EventRecord *event,Boolean isSuspended) = 0;
} Window;


#endif /* _WINDOW_ */
