#ifndef _PROCINFO_
#define _PROCINFO_

#include <ConditionalMacros.h>
#include <MixedMode.h>
#include "PhaseShiftConfig.h"


typedef pascal OSStatus (*PhaseShiftNubLoadProcPtr)(Handle code);
typedef pascal OSStatus (*PhaseShiftNubUnloadProcPtr)(Handle *code);
typedef pascal OSStatus (*PhaseShiftNubGetFSSpecProcPtr)(FSSpec *spec);
typedef pascal void (*SynchIdleTimePatchPtr)(void);
typedef pascal Boolean (*WaitNextEventPatchPtr)(EventMask mask,EventRecord *event,UInt32 sleep,RgnHandle mouse,Boolean result);
typedef pascal Boolean (*GetNextEventPatchPtr)(EventMask mask, EventRecord *event,Boolean result);
typedef pascal void (*InitWindowsPatchPtr)(void);
typedef pascal void (*InitApplicationPatchPtr)(void);
typedef pascal void (*VisRegionChangedPatchPtr)(WindowPtr window);
typedef pascal void (*FillRgnProcPtr)(RgnHandle rgn,const Pattern *pat);
typedef pascal void (*FillRgnPatchPtr)(RgnHandle rgn,const Pattern *pat,FillRgnProcPtr fillRgnProc);
typedef pascal void (*FillCRgnProcPtr)(RgnHandle rgn,PixPatHandle pp);
typedef pascal void (*FillCRgnPatchPtr)(RgnHandle rgn,PixPatHandle pp,FillCRgnProcPtr fillCRgnProc);
typedef pascal void (*FillRectProcPtr)(const Rect *r,const Pattern *pat);
typedef pascal void (*FillRectPatchPtr)(const Rect *r,const Pattern *pat,FillRectProcPtr fillRectProc);
typedef pascal void (*FrameRectProcPtr)(const Rect *r);
typedef pascal void (*FrameRectPatchPtr)(const Rect *r,FrameRectProcPtr frameRectProc);
typedef pascal void (*EraseRectProcPtr)(const Rect *r);
typedef pascal void (*EraseRectPatchPtr)(const Rect *r,EraseRectProcPtr eraseRectProc);
typedef pascal void (*PaintRectProcPtr)(const Rect *r);
typedef pascal void (*PaintRectPatchPtr)(const Rect *r,PaintRectProcPtr paintRectProc);
typedef pascal Boolean (*DMDrawDesktopRegionPatchPtr)(RgnHandle rgn);
typedef pascal void (*CopyMaskProcPtr)(const BitMap *srcBits,const BitMap *maskBits,
		const BitMap *dstBits,const Rect *srcRect,const Rect *maskRect,const Rect *dstRect);
typedef pascal void (*CopyMaskPatchPtr)(const BitMap *srcBits,const BitMap *maskBits,const BitMap *dstBits,
		const Rect *srcRect,const Rect *maskRect,const Rect *dstRect,CopyMaskProcPtr copyMaskProc);

#if GENERATINGCFM
typedef UniversalProcPtr 		PhaseShiftNubLoadUPP;
typedef UniversalProcPtr 		PhaseShiftNubUnloadUPP;
typedef UniversalProcPtr 		PhaseShiftNubGetFSSpecUPP;
typedef UniversalProcPtr 		SynchIdleTimePatchUPP;
typedef UniversalProcPtr 		WaitNextEventPatchUPP;
typedef UniversalProcPtr 		GetNextEventPatchUPP;
typedef UniversalProcPtr 		InitWindowsPatchUPP;
typedef UniversalProcPtr 		InitApplicationPatchUPP;
typedef UniversalProcPtr 		VisRegionChangedPatchUPP;
typedef UniversalProcPtr 		FillRgnProcUPP;
typedef UniversalProcPtr 		FillRgnPatchUPP;
typedef UniversalProcPtr 		FillCRgnProcUPP;
typedef UniversalProcPtr 		FillCRgnPatchUPP;
typedef UniversalProcPtr 		FillRectProcUPP;
typedef UniversalProcPtr 		FillRectPatchUPP;
typedef UniversalProcPtr 		FrameRectProcUPP;
typedef UniversalProcPtr 		FrameRectPatchUPP;
typedef UniversalProcPtr 		EraseRectProcUPP;
typedef UniversalProcPtr 		EraseRectPatchUPP;
typedef UniversalProcPtr 		PaintRectProcUPP;
typedef UniversalProcPtr 		PaintRectPatchUPP;
typedef UniversalProcPtr		DMDrawDesktopRegionPatchUPP;
typedef UniversalProcPtr		CopyMaskProcUPP;
typedef UniversalProcPtr		CopyMaskPatchUPP;
#else
typedef PhaseShiftNubLoadProcPtr		PhaseShiftNubLoadUPP;
typedef PhaseShiftNubUnloadProcPtr		PhaseShiftNubUnloadUPP;
typedef PhaseShiftNubGetFSSpecProcPtr	PhaseShiftNubGetFSSpecUPP;
typedef SynchIdleTimePatchPtr			SynchIdleTimePatchUPP;
typedef WaitNextEventPatchPtr			WaitNextEventPatchUPP;
typedef GetNextEventPatchPtr			GetNextEventPatchUPP;
typedef InitWindowsPatchPtr 			InitWindowsPatchUPP;
typedef InitApplicationPatchPtr 		InitApplicationPatchUPP;
typedef VisRegionChangedPatchPtr		VisRegionChangedPatchUPP;
typedef FillRgnProcPtr					FillRgnProcUPP;
typedef FillRgnPatchPtr					FillRgnPatchUPP;
typedef FillCRgnProcPtr					FillCRgnProcUPP;
typedef FillCRgnPatchPtr				FillCRgnPatchUPP;
typedef FillRectProcPtr			 		FillRectProcUPP;
typedef FillRectPatchPtr		 		FillRectPatchUPP;
typedef FrameRectProcPtr		 		FrameRectProcUPP;
typedef FrameRectPatchPtr		 		FrameRectPatchUPP;
typedef EraseRectProcPtr		 		EraseRectProcUPP;
typedef EraseRectPatchPtr		 		EraseRectPatchUPP;
typedef PaintRectProcPtr		 		PaintRectProcUPP;
typedef PaintRectPatchPtr		 		PaintRectPatchUPP;
typedef DMDrawDesktopRegionPatchPtr		DMDrawDesktopRegionPatchUPP;
typedef CopyMaskProcPtr					CopyMaskProcUPP;
typedef CopyMaskPatchPtr				CopyMaskPatchUPP;
#endif

enum {
	uppPhaseShiftNubLoadProcInfo = kPascalStackBased
		| RESULT_SIZE(SIZE_CODE(sizeof(OSStatus)))
		| STACK_ROUTINE_PARAMETER(1,SIZE_CODE(sizeof(Handle))),
	uppPhaseShiftNubUnloadProcInfo = kPascalStackBased
		| RESULT_SIZE(SIZE_CODE(sizeof(OSStatus)))
		| STACK_ROUTINE_PARAMETER(1,SIZE_CODE(sizeof(Handle*))),
	uppPhaseShiftNubGetFSSpecProcInfo = kPascalStackBased
		| RESULT_SIZE(SIZE_CODE(sizeof(OSStatus)))
		| STACK_ROUTINE_PARAMETER(1,SIZE_CODE(sizeof(FSSpec*))),
	uppSynchIdleTimePatchProcInfo = kPascalStackBased,
	uppWaitNextEventPatchProcInfo = kPascalStackBased
		 | RESULT_SIZE(SIZE_CODE(sizeof(Boolean)))
		 | STACK_ROUTINE_PARAMETER(1,SIZE_CODE(sizeof(EventMask)))
		 | STACK_ROUTINE_PARAMETER(2,SIZE_CODE(sizeof(EventRecord*)))
		 | STACK_ROUTINE_PARAMETER(3,SIZE_CODE(sizeof(UInt32)))
		 | STACK_ROUTINE_PARAMETER(4,SIZE_CODE(sizeof(RgnHandle)))
		 | STACK_ROUTINE_PARAMETER(5,SIZE_CODE(sizeof(Boolean))),
	uppGetNextEventPatchProcInfo = kPascalStackBased
		 | RESULT_SIZE(SIZE_CODE(sizeof(Boolean)))
		 | STACK_ROUTINE_PARAMETER(1,SIZE_CODE(sizeof(EventMask)))
		 | STACK_ROUTINE_PARAMETER(2,SIZE_CODE(sizeof(EventRecord*)))
		 | STACK_ROUTINE_PARAMETER(3,SIZE_CODE(sizeof(Boolean))),
	uppInitWindowsPatchProcInfo = kPascalStackBased,
	uppInitApplicationPatchProcInfo = kPascalStackBased,
	uppVisRegionChangedPatchProcInfo = kPascalStackBased
		| STACK_ROUTINE_PARAMETER(1,SIZE_CODE(sizeof(WindowPtr))),
	uppFillRgnProcInfo = kPascalStackBased
		| STACK_ROUTINE_PARAMETER(1,SIZE_CODE(sizeof(RgnHandle)))
		| STACK_ROUTINE_PARAMETER(2,SIZE_CODE(sizeof(const Pattern *))),
	uppFillRgnPatchProcInfo = kPascalStackBased
		| STACK_ROUTINE_PARAMETER(1,SIZE_CODE(sizeof(RgnHandle)))
		| STACK_ROUTINE_PARAMETER(2,SIZE_CODE(sizeof(const Pattern *)))
		| STACK_ROUTINE_PARAMETER(3,SIZE_CODE(sizeof(FillRgnProcPtr))),
	uppFillCRgnProcInfo = kPascalStackBased
		| STACK_ROUTINE_PARAMETER(1,SIZE_CODE(sizeof(RgnHandle)))
		| STACK_ROUTINE_PARAMETER(2,SIZE_CODE(sizeof(PixPatHandle))),
	uppFillCRgnPatchProcInfo = kPascalStackBased
		| STACK_ROUTINE_PARAMETER(1,SIZE_CODE(sizeof(RgnHandle)))
		| STACK_ROUTINE_PARAMETER(2,SIZE_CODE(sizeof(PixPatHandle)))
		| STACK_ROUTINE_PARAMETER(3,SIZE_CODE(sizeof(FillCRgnProcPtr))),
	uppFillRectProcInfo = kPascalStackBased
		| STACK_ROUTINE_PARAMETER(1,SIZE_CODE(sizeof(const Rect *)))
		| STACK_ROUTINE_PARAMETER(2,SIZE_CODE(sizeof(const Pattern *))),
	uppFillRectPatchProcInfo = kPascalStackBased
		| STACK_ROUTINE_PARAMETER(1,SIZE_CODE(sizeof(const Rect *)))
		| STACK_ROUTINE_PARAMETER(2,SIZE_CODE(sizeof(const Pattern *)))
		| STACK_ROUTINE_PARAMETER(3,SIZE_CODE(sizeof(FillRectProcPtr))),
	uppFrameRectProcInfo = kPascalStackBased
		| STACK_ROUTINE_PARAMETER(1,SIZE_CODE(sizeof(const Rect *))),
	uppFrameRectPatchProcInfo = kPascalStackBased
		| STACK_ROUTINE_PARAMETER(1,SIZE_CODE(sizeof(const Rect *)))
		| STACK_ROUTINE_PARAMETER(2,SIZE_CODE(sizeof(FrameRectProcPtr))),
	uppEraseRectProcInfo = kPascalStackBased
		| STACK_ROUTINE_PARAMETER(1,SIZE_CODE(sizeof(const Rect *))),
	uppEraseRectPatchProcInfo = kPascalStackBased
		| STACK_ROUTINE_PARAMETER(1,SIZE_CODE(sizeof(const Rect *)))
		| STACK_ROUTINE_PARAMETER(2,SIZE_CODE(sizeof(EraseRectProcPtr))),
	uppPaintRectProcInfo = kPascalStackBased
		| STACK_ROUTINE_PARAMETER(1,SIZE_CODE(sizeof(const Rect *))),
	uppPaintRectPatchProcInfo = kPascalStackBased
		| STACK_ROUTINE_PARAMETER(1,SIZE_CODE(sizeof(const Rect *)))
		| STACK_ROUTINE_PARAMETER(2,SIZE_CODE(sizeof(PaintRectProcPtr))),
	uppDMDrawDesktopRegionPatchProcInfo = kPascalStackBased
		 | RESULT_SIZE(SIZE_CODE(sizeof(Boolean)))
		 | STACK_ROUTINE_PARAMETER(1,SIZE_CODE(sizeof(RgnHandle))),
	uppCopyMaskProcInfo = kPascalStackBased
		| STACK_ROUTINE_PARAMETER(1,SIZE_CODE(sizeof(const BitMap *)))
		| STACK_ROUTINE_PARAMETER(2,SIZE_CODE(sizeof(const BitMap *)))
		| STACK_ROUTINE_PARAMETER(3,SIZE_CODE(sizeof(const BitMap *)))
		| STACK_ROUTINE_PARAMETER(4,SIZE_CODE(sizeof(const Rect *)))
		| STACK_ROUTINE_PARAMETER(5,SIZE_CODE(sizeof(const Rect *)))
		| STACK_ROUTINE_PARAMETER(6,SIZE_CODE(sizeof(const Rect *))),
	uppCopyMaskPatchProcInfo = kPascalStackBased
		| STACK_ROUTINE_PARAMETER(1,SIZE_CODE(sizeof(const BitMap *)))
		| STACK_ROUTINE_PARAMETER(2,SIZE_CODE(sizeof(const BitMap *)))
		| STACK_ROUTINE_PARAMETER(3,SIZE_CODE(sizeof(const BitMap *)))
		| STACK_ROUTINE_PARAMETER(4,SIZE_CODE(sizeof(const Rect *)))
		| STACK_ROUTINE_PARAMETER(5,SIZE_CODE(sizeof(const Rect *)))
		| STACK_ROUTINE_PARAMETER(6,SIZE_CODE(sizeof(const Rect *)))
		| STACK_ROUTINE_PARAMETER(7,SIZE_CODE(sizeof(CopyMaskProcPtr)))
};

#if GENERATINGCFM
#define NewPhaseShiftNubLoadProc(userRoutine)		(PhaseShiftNubLoadUPP)NewRoutineDescriptor((ProcPtr)(userRoutine),uppPhaseShiftNubLoadProcInfo,GetCurrentArchitecture())
#define NewPhaseShiftNubUnloadProc(userRoutine)		(PhaseShiftNubUnloadUPP)NewRoutineDescriptor((ProcPtr)(userRoutine),uppPhaseShiftNubUnloadProcInfo,GetCurrentArchitecture())
#define NewPhaseShiftNubGetFSSpecProc(userRoutine)	(PhaseShiftNubGetFSSpecUPP)NewRoutineDescriptor((ProcPtr)(userRoutine),uppPhaseShiftNubGetFSSpecProcInfo,GetCurrentArchitecture())
#define NewSynchIdleTimePatch(userRoutine)			(SynchIdleTimePatchUPP)NewRoutineDescriptor((ProcPtr)(userRoutine),uppSynchIdleTimePatchProcInfo,GetCurrentArchitecture())
#define NewWaitNextEventPatch(userRoutine)			(WaitNextEventPatchUPP)NewRoutineDescriptor((ProcPtr)(userRoutine),uppWaitNextEventPatchProcInfo,GetCurrentArchitecture())
#define NewGetNextEventPatch(userRoutine)			(GetNextEventPatchUPP)NewRoutineDescriptor((ProcPtr)(userRoutine),uppGetNextEventPatchProcInfo,GetCurrentArchitecture())
#define NewInitWindowsPatch(userRoutine)			(InitWindowsPatchUPP)NewRoutineDescriptor((ProcPtr)(userRoutine),uppInitWindowsPatchProcInfo,GetCurrentArchitecture())
#define NewInitApplicationPatch(userRoutine)		(InitApplicationPatchUPP)NewRoutineDescriptor((ProcPtr)(userRoutine),uppInitApplicationPatchProcInfo,GetCurrentArchitecture())
#define NewVisRegionChangedPatch(userRoutine)		(VisRegionChangedPatchUPP)NewRoutineDescriptor((ProcPtr)(userRoutine),uppVisRegionChangedPatchProcInfo,GetCurrentArchitecture())
#define NewFillRgnProc(userRoutine)					(FillRgnProcUPP)NewRoutineDescriptor((ProcPtr)(userRoutine),uppFillRgnProcInfo,GetCurrentArchitecture())
#define NewFillRgnPatch(userRoutine)				(FillRgnPatchUPP)NewRoutineDescriptor((ProcPtr)(userRoutine),uppFillRgnPatchProcInfo,GetCurrentArchitecture())
#define NewFillCRgnProc(userRoutine)				(FillCRgnProcUPP)NewRoutineDescriptor((ProcPtr)(userRoutine),uppFillCRgnProcInfo,GetCurrentArchitecture())
#define NewFillCRgnPatch(userRoutine)				(FillCRgnPatchUPP)NewRoutineDescriptor((ProcPtr)(userRoutine),uppFillCRgnPatchProcInfo,GetCurrentArchitecture())
#define NewFillRectProc(userRoutine)				(FillRectProcUPP)NewRoutineDescriptor((ProcPtr)(userRoutine),uppFillRectProcInfo,GetCurrentArchitecture())
#define NewFillRectPatch(userRoutine)				(FillRectPatchUPP)NewRoutineDescriptor((ProcPtr)(userRoutine),uppFillRectPatchProcInfo,GetCurrentArchitecture())
#define NewFrameRectProc(userRoutine)				(FrameRectProcUPP)NewRoutineDescriptor((ProcPtr)(userRoutine),uppFrameRectProcInfo,GetCurrentArchitecture())
#define NewFrameRectPatch(userRoutine)				(FrameRectPatchUPP)NewRoutineDescriptor((ProcPtr)(userRoutine),uppFrameRectPatchProcInfo,GetCurrentArchitecture())
#define NewEraseRectProc(userRoutine)				(EraseRectProcUPP)NewRoutineDescriptor((ProcPtr)(userRoutine),uppEraseRectProcInfo,GetCurrentArchitecture())
#define NewEraseRectPatch(userRoutine)				(EraseRectPatchUPP)NewRoutineDescriptor((ProcPtr)(userRoutine),uppEraseRectPatchProcInfo,GetCurrentArchitecture())
#define NewPaintRectProc(userRoutine)				(PaintRectProcUPP)NewRoutineDescriptor((ProcPtr)(userRoutine),uppPaintRectProcInfo,GetCurrentArchitecture())
#define NewPaintRectPatch(userRoutine)				(PaintRectPatchUPP)NewRoutineDescriptor((ProcPtr)(userRoutine),uppPaintRectPatchProcInfo,GetCurrentArchitecture())
#define NewDMDrawDesktopRegionPatch(userRoutine)	(DMDrawDesktopRegionPatchUPP)NewRoutineDescriptor((ProcPtr)(userRoutine),uppDMDrawDesktopRegionPatchProcInfo,GetCurrentArchitecture())
#define NewCopyMaskProc(userRoutine)				(CopyMaskProcUPP)NewRoutineDescriptor((ProcPtr)(userRoutine),uppCopyMaskProcInfo,GetCurrentArchitecture())
#define NewCopyMaskPatch(userRoutine)				(CopyMaskPatchUPP)NewRoutineDescriptor((ProcPtr)(userRoutine),uppCopyMaskPatchProcInfo,GetCurrentArchitecture())
#else
#define NewPhaseShiftNubLoadProc(userRoutine)		((PhaseShiftNubLoadUPP)(userRoutine))
#define NewPhaseShiftNubUnloadProc(userRoutine)		((PhaseShiftNubUnloadUPP)(userRoutine))
#define NewPhaseShiftNubGetFSSpecProc(userRoutine)	((PhaseShiftNubGetFSSpecUPP)(userRoutine))
#define NewSynchIdleTimePatch(userRoutine)			((SynchIdleTimePatchUPP)(userRoutine))
#define NewWaitNextEventPatch(userRoutine)			((WaitNextEventPatchUPP)(userRoutine))
#define NewGetNextEventPatch(userRoutine)			((GetNextEventPatchUPP)(userRoutine))
#define NewInitWindowsPatch(userRoutine)			((InitWindowsPatchUPP)(userRoutine))
#define NewInitApplicationPatch(userRoutine)		((InitApplicationPatchUPP)(userRoutine))
#define NewVisRegionChangedPatch(userRoutine)		((VisRegionChangedPatchUPP)(userRoutine))
#define NewFillRgnProc(userRoutine)					((FillRgnProcUPP)(userRoutine))
#define NewFillRgnPatch(userRoutine)				((FillRgnPatchUPP)(userRoutine))
#define NewFillCRgnProc(userRoutine)				((FillCRgnProcUPP)(userRoutine))
#define NewFillCRgnPatch(userRoutine)				((FillCRgnPatchUPP)(userRoutine))
#define NewFillRectProc(userRoutine)				((FillRectProcUPP)(userRoutine))
#define NewFillRectPatch(userRoutine)				((FillRectPatchUPP)(userRoutine))
#define NewFrameRectProc(userRoutine)				((FrameRectProcUPP)(userRoutine))
#define NewFrameRectPatch(userRoutine)				((FrameRectPatchUPP)(userRoutine))
#define NewEraseRectProc(userRoutine)				((EraseRectProcUPP)(userRoutine))
#define NewEraseRectPatch(userRoutine)				((EraseRectPatchUPP)(userRoutine))
#define NewPaintRectProc(userRoutine)				((PaintRectProcUPP)(userRoutine))
#define NewPaintRectPatch(userRoutine)				((PaintRectPatchUPP)(userRoutine))
#define NewDMDrawDesktopRegionPatch(userRoutine)	((DMDrawDesktopRegionPatchUPP)(userRoutine))
#define NewCopyMaskProc(userRoutine)				((CopyMaskProcUPP)(userRoutine))
#define NewCopyMaskPatch(userRoutine)				((CopyMaskPatchUPP)(userRoutine))
#endif

#if GENERATINGCFM
#define CallPhaseShiftNubLoadProc(userRoutine,code)								CallUniversalProc((UniversalProcPtr)(userRoutine),uppPhaseShiftNubLoadProcInfo,(code))
#define CallPhaseShiftNubUnloadProc(userRoutine,code)							CallUniversalProc((UniversalProcPtr)(userRoutine),uppPhaseShiftNubUnloadProcInfo,(code))
#define CallPhaseShiftNubGetFSSpecProc(userRoutine,spec)						CallUniversalProc((UniversalProcPtr)(userRoutine),uppPhaseShiftNubGetFSSpecProcInfo,(spec))
#define CallSynchIdleTimePatch(userRoutine)										CallUniversalProc((UniversalProcPtr)(userRoutine),uppSynchIdleTimePatchProcInfo)
#define CallWaitNextEventPatch(userRoutine,mask,event,sleep,mouse,result)		CallUniversalProc((UniversalProcPtr)(userRoutine),uppWaitNextEventPatchProcInfo,(mask),(event),(sleep),(mouse),(result))
#define CallGetNextEventPatch(userRoutine,mask,event,result)					CallUniversalProc((UniversalProcPtr)(userRoutine),uppGetNextEventPatchProcInfo,(mask),(event),(result))
#define CallInitWindowsPatch(userRoutine)										CallUniversalProc((UniversalProcPtr)(userRoutine),uppInitWindowsPatchProcInfo)
#define CallInitApplicationPatch(userRoutine)									CallUniversalProc((UniversalProcPtr)(userRoutine),uppInitApplicationPatchProcInfo)
#define CallVisRegionChangedPatch(userRoutine,window)							CallUniversalProc((UniversalProcPtr)(userRoutine),uppVisRegionChangedPatchProcInfo,(window))
#define CallFillRgnProc(userRoutine,rgn,pat)									CallUniversalProc((UniversalProcPtr)(userRoutine),uppFillRgnProcInfo,(rgn),(pat))
#define CallFillRgnPatch(userRoutine,rgn,pat,proc)								CallUniversalProc((UniversalProcPtr)(userRoutine),uppFillRgnPatchProcInfo,(rgn),(pat),(proc))
#define CallFillCRgnProc(userRoutine,rgn,pp)									CallUniversalProc((UniversalProcPtr)(userRoutine),uppFillCRgnProcInfo,(rgn),(pp))
#define CallFillCRgnPatch(userRoutine,rgn,pp,proc)								CallUniversalProc((UniversalProcPtr)(userRoutine),uppFillCRgnPatchProcInfo,(rgn),(pp),(proc))
#define CallFillRectProc(userRoutine,r,pat)										CallUniversalProc((UniversalProcPtr)(userRoutine),uppFillRectProcInfo,(r),(pat))
#define CallFillRectPatch(userRoutine,r,pat,proc)								CallUniversalProc((UniversalProcPtr)(userRoutine),uppFillRectPatchProcInfo,(r),(pat),(proc))
#define CallFrameRectProc(userRoutine,r)										CallUniversalProc((UniversalProcPtr)(userRoutine),uppFrameRectProcInfo,(r))
#define CallFrameRectPatch(userRoutine,r,proc)									CallUniversalProc((UniversalProcPtr)(userRoutine),uppFrameRectPatchProcInfo,(r),(proc))
#define CallEraseRectProc(userRoutine,r)										CallUniversalProc((UniversalProcPtr)(userRoutine),uppEraseRectProcInfo,(r))
#define CallEraseRectPatch(userRoutine,r,proc)									CallUniversalProc((UniversalProcPtr)(userRoutine),uppEraseRectPatchProcInfo,(r),(proc))
#define CallPaintRectProc(userRoutine,r)										CallUniversalProc((UniversalProcPtr)(userRoutine),uppPaintRectProcInfo,(r))
#define CallPaintRectPatch(userRoutine,r,proc)									CallUniversalProc((UniversalProcPtr)(userRoutine),uppPaintRectPatchProcInfo,(r),(proc))
#define CallDMDrawDesktopRegionPatch(userRoutine,rgn)							CallUniversalProc((UniversalProcPtr)(userRoutine),uppDMDrawDesktopRegionPatchProcInfo,(rgn))
#define CallCopyMaskProc(userRoutine,sb,mb,db,sr,mr,dr)							CallUniversalProc((UniversalProcPtr)(userRoutine),uppCopyMaskProcInfo,(sb),(mb),(db),(sr),(mr),(dr))
#define CallCopyMaskPatch(userRoutine,sb,mb,db,sr,mr,dr,proc)					CallUniversalProc((UniversalProcPtr)(userRoutine),uppCopyMaskPatchProcInfo,(sb),(mb),(db),(sr),(mr),(dr),(proc))
#else
#define CallPhaseShiftNubLoadProc(userRoutine,code)								(*(PhaseShiftNubLoadProcPtr)(userRoutine))((code))
#define CallPhaseShiftNubUnloadProc(userRoutine,code)							(*(PhaseShiftNubUnloadProcPtr)(userRoutine))((code))
#define CallPhaseShiftNubGetFSSpecProc(userRoutine,spec)						(*(PhaseShiftNubGetFSSpecProcPtr)(userRoutine))((spec))
#define CallSynchIdleTimePatch(userRoutine)										(*(SynchIdleTimePatchPtr)(userRoutine))()
#define CallWaitNextEventPatch(userRoutine,mask,event,sleep,mouse,result)		(*(WaitNextEventPatchPtr)(userRoutine))((mask),(event),(sleep),(mouse),(result))
#define CallGetNextEventPatch(userRoutine,mask,event,result)					(*(GetNextEventPatchPtr)(userRoutine))((mask),(event),(result))
#define CallInitWindowsPatch(userRoutine)										(*(InitWindowsPatchPtr)(userRoutine))()
#define CallInitApplicationPatch(userRoutine)									(*(InitApplicationPatchPtr)(userRoutine))()
#define CallVisRegionChangedPatch(userRoutine,window)							(*(VisRegionChangedPatchPtr)(userRoutine))((window))
#define CallFillRgnProc(userRoutine,rgn,pat)									(*(FillRgnProcPtr)(userRoutine))((rgn),(pat))
#define CallFillRgnPatch(userRoutine,rgn,pat,proc)								(*(FillRgnProcPtr)(userRoutine))((rgn),(pat),(proc))
#define CallFillCRgnProc(userRoutine,rgn,pp)									(*(FillCRgnProcPtr)(userRoutine))((rgn),(pp))
#define CallFillCRgnPatch(userRoutine,rgn,pp,proc)								(*(FillCRgnProcPtr)(userRoutine))((rgn),(pp),(proc))
#define CallFillRectProc(userRoutine,r,pat)										(*(FillRectProcPtr)(userRoutine))((r),(pat))
#define CallFillRectPatch(userRoutine,r,pat,proc)								(*(FillRectPatchPtr)(userRoutine))((r),(pat),(proc))
#define CallFrameRectProc(userRoutine,r)										(*(FrameRectProcPtr)(userRoutine))((r))
#define CallFrameRectPatch(userRoutine,r,proc)									(*(FrameRectPatchPtr)(userRoutine))((r),(proc))
#define CallEraseRectProc(userRoutine,r)										(*(EraseRectProcPtr)(userRoutine))((r))
#define CallEraseRectPatch(userRoutine,r,proc)									(*(EraseRectPatchPtr)(userRoutine))((r),(proc))
#define CallPaintRectProc(userRoutine,r)										(*(PaintRectProcPtr)(userRoutine))((r))
#define CallPaintRectPatch(userRoutine,r,proc)									(*(PaintRectPatchPtr)(userRoutine))((r),(proc))
#define CallDMDrawDesktopRegionPatch(userRoutine,rgn)							(*(DMDrawDesktopRegionPatchPtr)(userRoutine))((rgn))
#define CallCopyMaskProc(userRoutine,sb,mb,db,sr,mr,dr)							(*(CopyMaskProcPtr)(userRoutine))((sb),(mb),(db),(sr),(mr),(dr))
#define CallCopyMaskPatch(userRoutine,sb,mb,db,sr,mr,dr,proc)					(*(CopyMaskPatchPtr)(userRoutine))((sb),(mb),(db),(sr),(mr),(dr),(proc))
#endif


#endif /* _PROCINFO_ */
