#include <vector>

class CD;

class CDDrive {

  public:
	class Iterator {
	  public:
		Iterator();
		bool More() const;
		CDDrive Next();
	  private:
		void Skip();
		void Advance();
		bool IsCD() const;
		short CurrentRefNum() const;
		static bool IsCDDriverName(const unsigned char[]);
		short mCurrentUnitNumber;
	};
	
	bool Empty() const;
	void Eject() const;
	static unsigned NumDrives();

  private:
	static bool AudioTrack(unsigned long trackStart);
	friend class Iterator;

	CDDrive(short);
	short mRefNum;
};
