#ifndef __CImageView_H__
#define __CImageView_H__
#pragma once

#include <LView.h>

class LGWorld;

class CImageView : public LView
{
public:
	enum { class_ID = 'imgv' };
								CImageView (LStream * inStream);
	virtual						~CImageView ();

	void			AdoptImage(LGWorld* image);
	void			SetImage(LGWorld* image);

	void			AdoptMask(LGWorld* image);
	void			SetMask(LGWorld* image);

	virtual void	DrawSelf();
	
	static LGWorld*	GWorldFromPict(int pictID, int bitDepth = 32);
	static LGWorld*	GWorldFromGIF(void *buffer, int bufferLength, int bitDepth = 32);
	static void		DrawWithMask(LGWorld* image, LGWorld* mask, GrafPtr targetPort, int offsetH, int offsetV);
	
protected:
	void			AssignImage(LGWorld* image, bool owns);
	void			AssignMask(LGWorld* image, bool owns);

	LGWorld*		fImage;
	LGWorld*		fMask;
	int				fOffsetH;
	int				fOffsetV;
	bool			fOwnsImage;
	bool			fOwnsMask;
};

#endif
