// ===========================================================================
//	CPalmPadApp.h				1994-1998 Metrowerks Inc. All rights reserved.
// ===========================================================================

#pragma once

#include <PP_Prefix.h>
#include <LApplication.h>
#include <CursorDevices.h>

#include "IRTransfer.h"


class	CPalmPadApp : public PP_PowerPlant::LApplication {

public:
							CPalmPadApp();		// constructor registers PPobs
		virtual				~CPalmPadApp();		// stub destructor
	
	
		// this overriding method handles application commands
		virtual Boolean		ObeyCommand(PP_PowerPlant::CommandT inCommand, void* ioParam);	
	
	
		// this overriding method returns the status of menu items
		virtual void		FindCommandStatus(PP_PowerPlant::CommandT inCommand,
									Boolean &outEnabled, Boolean &outUsesMark,
									PP_PowerPlant::Char16 &outMark, Str255 outName);
		static LGWorld* DumpScreenArea();
		
		IRTransfer::GraphicsData* GWorldToGraphicsData(LGWorld* world);

protected:

		virtual void		StartUp();			// override startup functions
		
		void SendNullPacket();
		void DoEject();
		void DoAbout();

		void HandlePacket();
		void HandleMousePacket(const void *, Int32);
		void HandleRequestGraphicsPacket(const void *, Int32);
		void HandleButtonsPacket(const void *, Int32);
		
		static void			ReadDataWrapper(LThread&, void* arg);
		void				ReadData();
		
		static void			SendDataWrapper(LThread&, void* arg);
		void				SendData();
		
		void				CaptureScreen();
		
	Rect fScreenRect;
	IRTransfer::MouseData fMouseData;
	CursorDevicePtr fCursorDevice;

};