#include "Str255.h"

#include <LString.h>

std::string
AsString(ConstStr255Param in)
{
	return std::string(reinterpret_cast<const char*>(&in[1]), in[0]);
}

void
CopyToStr255(const std::string& in, Str255 out)
{
	unsigned size = in.size();
	if (size > 255)
		size = 255;
	out[0] = size;
	in.copy(reinterpret_cast<char*>(&out[1]), size);
}

Str255Converter
AsStr255(const std::string& in)
{
	return in;
}

Str255Converter::Str255Converter(const std::string& in)
{
	CopyToStr255(in, mStr255);
}

Str255Converter::operator const unsigned char*() const
{
	return mStr255;
}

std::string&
operator+=(std::string& string, ConstStr255Param other)
{
	string.append(reinterpret_cast<const char*>(&other[1]), other[0]); 
	return string;
}

std::string
operator+(const std::string& string, ConstStr255Param other)
{
	std::string result(string);
	return result += other;
}

