// CopyAction.h

#ifndef CopyAction_h
#define CopyAction_h

#ifndef Action_h
#include "Action.h"
#endif
#ifndef AEEvent_h
#include "AEEvent.h"
#endif

class FileLocation;
class Directory;
class CatInfo;

class CopyAction: public Action
  {
	private:
		AEList selection;
		AEEvent event;
	
		static bool CouldBeCopy( const CatInfo& original,
										 const CatInfo& copy );
		
		static FileLocation FindCopy( const FileLocation& original,
												Directory parent );
		
	public:
		void SetEvent( const AEList& selection,
							const AEEvent& event );
		
		virtual void Undo();
		virtual void Redo();
  };

#endif
