// LockAction.cp

#ifndef LockAction_h
#include "LockAction.h"
#endif
#ifndef AEGetter_h
#include "AEGetter.h"
#endif
#ifndef AEStruct_h
#include "AEStruct.h"
#endif
#ifndef FileLocation_h
#include "FileLocation.h"
#endif
#ifndef HaveFinderResolve_h
#include "HaveFinderResolve.h"
#endif
#ifndef OSError_h
#include "OSError.h"
#endif
#ifndef ConfigureFinderUpdating_h
#include "ConfigureFinderUpdating.h"
#endif
#ifndef HaveFinderUpdate_h
#include "HaveFinderUpdate.h"
#endif

void LockAction::SetEvent( const AEEvent& lockEvent )
  {
	AEDescriptor eventCopy( lockEvent );
	eventCopy.Swap( event );
	
	locking = AEGetter<typeBoolean>( event.Parameter( 'data' ) );
  }

void LockAction::Undo()
  {
	AEStruct directObject( event.Parameter( keyDirectObject ) );
	AEDescriptor fileDescriptor( directObject['from'] );
	
	FileLocation file = HaveFinderResolve( fileDescriptor );
	
	if (locking)
		ThrowOSError( FSpRstFLock( &file ) );
	 else
		ThrowOSError( FSpSetFLock( &file ) );

	if ( sendUpdateEventsToFinder )
		HaveFinderUpdate( FileLocation( file.Parent() ) );
  }

void LockAction::Redo()
  {	
	AEEvent reply;
	ThrowOSError( AESend( &event,
								 &reply,
								 kAEWaitReply,
								 kAENormalPriority,
								 kAEDefaultTimeout,
								 AEEvent::IgnoreIncomingEvents(),
								 0 ) );	// filterProc
  }
