// RenameAction.cp

#ifndef RenameAction_h
#include "RenameAction.h"
#endif
#ifndef FileLocation_h
#include "FileLocation.h"
#endif
#ifndef HaveFinderResolve_h
#include "HaveFinderResolve.h"
#endif
#ifndef BufferMaster_h
#include "BufferMaster.h"
#endif
#ifndef OSError_h
#include "OSError.h"
#endif
#ifndef HaveFinderUpdate_h
#include "HaveFinderUpdate.h"
#endif
#ifndef HaveFinderSelect_h
#include "HaveFinderSelect.h"
#endif
#ifndef ConfigureFinderUpdating_h
#include "ConfigureFinderUpdating.h"
#endif

void RenameAction::SetEvent( const AEList& newSelection,
									  const AEEvent& renameEvent )
  {
	AEDescriptor selectionCopy( newSelection );
	selectionCopy.Swap( selection );

	AEDescriptor eventCopy( renameEvent );
	eventCopy.Swap( event );
  }

void RenameAction::Undo()
  {
	Assert( selection.Length() == 1 );
	AEDescriptor renamedFileDescriptor( selection[1] );	
	FileLocation before = HaveFinderResolveByParent( renamedFileDescriptor );
		
	Str63 name;
	BufferMaster buffer( Data( name + 1, sizeof(name) - 1 ) );
	event.Parameter( 'data' ) >> buffer;
	name[0] = buffer.UsedLength();

	FileLocation after = before.Sibling( name );
	
	ThrowOSError( FSpRename( &after, before.Name() ) );

	if ( sendUpdateEventsToFinder )
		HaveFinderUpdate( FileLocation( before.Parent() ) );

	HaveFinderSelect( before );
  }

void RenameAction::Redo()
  {
	HaveFinderSelect( selection );
	
	AEEvent reply;
	ThrowOSError( AESend( &event,
								 &reply,
								 kAEWaitReply,
								 kAENormalPriority,
								 kAEDefaultTimeout,
								 AEEvent::IgnoreIncomingEvents(),
								 0 ) );	// filterProc
  }
