// Unfinder.h

#ifndef Unfinder_h
#define Unfinder_h

#ifndef ActionLocus_h
#include "ActionLocus.h"
#endif
#ifndef AppleEventRecorder_h
#include "AppleEventRecorder.h"
#endif
#ifndef AEList_h
#include "AEList.h"
#endif

class FileSignature;
class AEVerb;
class FileLocation;

class Unfinder: public ActionLocus,
					 public AppleEventRecorder
  {
	private:
		Unfinder();
		~Unfinder()		{}
	
		AEList selection;
		
		static FileSignature TargetSignature( const AEEvent& );
		
		void RecordCoreEvent( AEVerb, const AEEvent& );
		void RecordFinderEvent( AEVerb, const AEEvent& );
		void RecordMiscellaneousEvent( AEVerb, const AEEvent& );
		
		void RecordUnknownEvent( AEVerb, const AEEvent& );
		
		void RecordMake( const AEEvent& );
		void RecordMove( const AEEvent& );
		void RecordDelete( const AEEvent& );
		void RecordDuplicate( const AEEvent& );
		void RecordSetData( const AEEvent& );
		void RecordSelect( const AEEvent& );
		
	public:
		static Unfinder& The();

		virtual void Record( const AEEvent& );
  };

#endif
