// HaveFinderSelect.cp

#ifndef HaveFinderSelect_h
#include "HaveFinderSelect.h"
#endif
#ifndef AEAddress_h
#include "AEAddress.h"
#endif
#ifndef AEEvent_h
#include "AEEvent.h"
#endif
#ifndef OSError_h
#include "OSError.h"
#endif

void HaveFinderSelect( const FSSpec& toSelect )
  {
	static const AEAddress finder( FileSignature::Finder() );
	AEEvent selectEvent( kAEMiscStandards, kAESelect, finder );
		
	const ConstData fileSpecBlock( &toSelect, sizeof( toSelect ) );
	selectEvent.Parameter( keyDirectObject ).Set( typeFSS, fileSpecBlock );
	
	AEEvent reply;
	ThrowOSError( AESend( &selectEvent,
								 &reply,
								 kAEWaitReply,
								 kAENormalPriority,
								 kAEDefaultTimeout,
								 AEEvent::IgnoreIncomingEvents(),
								 0 ) );	// filterProc
  }

void HaveFinderSelect( const AEDescriptor& toSelect )
  {
	static const AEAddress finder( FileSignature::Finder() );
	AEEvent selectEvent( kAEMiscStandards, kAESelect, finder );
		
	selectEvent.Parameter( keyDirectObject ) = toSelect;
	
	AEEvent reply;
	ThrowOSError( AESend( &selectEvent,
								 &reply,
								 kAEWaitReply,
								 kAENormalPriority,
								 kAEDefaultTimeout,
								 AEEvent::IgnoreIncomingEvents(),
								 0 ) );	// filterProc
  }
