// HaveFinderUpdate.cp

#ifndef HaveFinderUpdate_h
#include "HaveFinderUpdate.h"
#endif
#ifndef AEEvent_h
#include "AEEvent.h"
#endif
#ifndef OSError_h
#include "OSError.h"
#endif
#ifndef AEAddress_h
#include "AEAddress.h"
#endif
#ifndef __APPLEEVENTS__
#include <AppleEvents.h>
#endif
#ifndef __AEREGISTRY__
#include <AERegistry.h>
#endif
#ifndef __FINDERREGISTRY__
#include <FinderRegistry.h>
#endif

void HaveFinderUpdate( const FSSpec& folder )
  {
	static const AEAddress finder( FileSignature::Finder() );
	AEEvent updateEvent( kAEFinderSuite, kAESync, finder );
		
	const ConstData fileSpecBlock( &folder, sizeof( folder ) );
	updateEvent.Parameter( keyDirectObject ).Set( typeFSS, fileSpecBlock );
	
	AEEvent reply;
	ThrowOSError( AESend( &updateEvent,
								 &reply,
								 kAENoReply,
								 kAENormalPriority,
								 kAEDefaultTimeout,
								 0,		// idleProc
								 0 ) );	// filterProc
  }

void HaveFinderUpdate( const AEDescriptor& folder )
  {
	static const AEAddress finder( FileSignature::Finder() );
	AEEvent updateEvent( kAEFinderSuite, kAESync, finder );
		
	updateEvent.Parameter( keyDirectObject ) = folder;
	
	AEEvent reply;
	ThrowOSError( AESend( &updateEvent,
								 &reply,
								 kAENoReply,
								 kAENormalPriority,
								 kAEDefaultTimeout,
								 0,		// idleProc
								 0 ) );	// filterProc
  }
