// FinderAliasNamingLoop.cp

#ifndef FinderAliasNamingLoop_h
#include "FinderAliasNamingLoop.h"
#endif

FinderAliasNamingLoop::FinderAliasNamingLoop( ConstPString theBaseName,
															 ConstPString theModifier )
  : baseName( theBaseName ),
	 modifier( theModifier ),
	 number( 0 )
  {
	BuildName();
  }

void FinderAliasNamingLoop::operator++()
  {
	Assert( number < maxuint32 );
	number++;
	BuildName();
  }

void FinderAliasNamingLoop::BuildName()
  {
	Str255 numeral;
	
	if ( number == 0 )
		numeral[0] = 0;
	 else
		NumToString( number, numeral );
	
	ConstPString firstSpace =  (baseName.Length() > 0 && modifier.Length() > 0)
										? "\p " : "\p";
	ConstPString secondSpace = (number > 0 & number < 10) ? "\p " : "\p";

	ConstData base( baseName );
	base.LimitLength( 31 - firstSpace.Length() - modifier.Length() );
	
	total = base;
	total += firstSpace;
	total += modifier;
	
	uint32 tailLength = secondSpace.Length() + numeral[0];
	Assert( tailLength <= 31 );
	
	if ( total.Length() > 31 - tailLength )
		total.Truncate( 31 - tailLength );
	
	total += secondSpace;
	total += numeral;
  }
