// FinderNamingLoop.cp

#ifndef FinderNamingLoop_h
#include "FinderNamingLoop.h"
#endif

FinderNamingLoop::FinderNamingLoop( ConstPString theBaseName,
												ConstPString theModifier )
  : baseName( theBaseName ),
	 modifier( theModifier ),
	 number( 0 )
  {
	Assert( theModifier.Length() < 20 );
	BuildName();
  }

void FinderNamingLoop::operator++()
  {
	Assert( number < maxuint32 );
	number++;
	BuildName();
  }

void FinderNamingLoop::BuildName()
  {
	Str255 numeral;
	
	if ( number == 0 )
		numeral[0] = 0;
	 else
		NumToString( number, numeral );
	
	ConstPString firstSpace =  (baseName.Length() > 0 && modifier.Length() > 0) 
										? "\p " : "\p";
	ConstPString secondSpace = (number > 0 & number < 10) ? "\p " : "\p";
	
	uint32 tailLength = firstSpace.Length()
							+ modifier.Length()
							+ secondSpace.Length()
							+ numeral[0];
	Assert( tailLength < 31 );
	
	ConstData base( baseName );
	base.LimitLength( 31 - tailLength );
	
	total = base;
	total += firstSpace;
	total += modifier;
	total += secondSpace;
	total += numeral;
  }
