// FinderNamingLoop.h

#ifndef FinderNamingLoop_h
#define FinderNamingLoop_h

#ifndef Str_h
#include "Str.h"
#endif

/*
	This loop tries to mimic the way the 8.5/8.6 Finder
	builds file names for duplicates and new folders.
	
	In English, the Finder uses these parameters:
	
		for duplicates: baseName is the original name, modifier is "copy"
		for new folders: baseName is empty, modifier is "untitled folder"
	
	The Finder uses a different algorithm for aliases, and that's
	probably a bug.  See FinderAliasNamingLoop.
*/

class FinderNamingLoop
  {
	private:
		ConstPString baseName;
		ConstPString modifier;
		uint32 number;
		String31 total;

		void BuildName();
		
	public:
		FinderNamingLoop( ConstPString baseName, ConstPString modifier );
		
		void operator++();
		void operator++(int)					{ operator++(); }
		
		ConstPString operator*() const	{ return total; }
  };

#endif
